<script>
import { page } from '$app/stores';
import Player from '@/components/player.svelte';
import back from '@/plugins/axios.js';
import { goto } from '$app/navigation';
import { socketStore } from '@/plugins/socket.js';
import { topics } from '@/plugins/store.js';
import { onDestroy, onMount } from 'svelte';
import { splitIntoDigits } from '@/plugins/utils';
import Digit from '@/components/digit.svelte';

let stream_id = $page.params.id;

// Gets streamer from backend
let streamID = "";
let streamers = {}
let sorted_filtered_streamers = []
let unsubscribe;

$: {
    if (!unsubscribe) {
        socketStore.update(store => {
            unsubscribe = store.subscribe(message => {
                // Do something with the message here
                try {
                    let m = JSON.parse(message)

                    if ("op" in m || !(m.r.match("streamers\\.\\d+\\.live"))) {
                        return;
                    }

                    update(m.d, m.d.streamerID);

                } catch (e) {
                    console.log(e)
                }
            });
            return store;
        });
    }
}

onMount(() => {
    back.get('/streamers/'+stream_id)
    .then(response => {
        streamID = response.data.twitch_id;
    })
    .catch((err) => {
        console.log(err);
        // Redir in 3 seconds
        setTimeout(() => {
            goto('/');
        }, 3000);
    });

    // Gets streamers from backend
    back.get('/streamers/')
    .then(response => {
        for (let i = 0; i < response.data.length; i++) {
            if (!streamers[response.data[i].id]) {
                streamers[response.data[i].id] = response.data[i]
            } else {
                streamers[response.data[i].id].twitch_id = response.data[i].twitch_id
                streamers[response.data[i].id].id = response.data[i].id
            }
        }
    })
    .catch(error => {
        console.log(error);
    });

    // Add a topic to the socket
    topics.sub("streamers.*.live");
});

function update(data, id) {
    // update the streamer
    if (!streamers[id]) {
        streamers[id] = {}
    }
    streamers[id].is_live = data.isLive
    streamers[id].view_count = data.viewCount
    // update the sorted_filtered_streamers
    sorted_filtered_streamers = []
    // Sort streamers by number of viewers and remove streamers offline
    for (let i = 0; i < Object.keys(streamers).length; i++) {
        if (streamers[Object.keys(streamers)[i]].is_live && streamers[Object.keys(streamers)[i]].id != stream_id) {
            sorted_filtered_streamers.push(streamers[Object.keys(streamers)[i]])
        }
    }
    sorted_filtered_streamers.sort((a, b) => {
        return b.view_count - a.view_count
    })
}

onDestroy(() => {
    console.log("Destroying")
    unsubscribe();
    // Remove the topic from the socket
    topics.unsub("streamers.*.live")
});

</script>

{#if streamID != ""}
<div class="grid lg:grid-cols-5 grid-rows-2 m-5 gap-1   " >
    <div class="col-span-4" style="max-width:1400px; max-height:1000px; height:100%; width:100%">
        <Player class="" streamID="{streamID}" />
    </div>

    <div class="flex flex-col items-center lg:ml-10 p-10 lg:bg-base-200 bg-base-100 rounded-lg lg:mt-0">
        <!-- title -->
        <span class="text-3xl font-bold lg:mb-5">Streamers en ligne :</span>
        <div class="overflow-auto" style="max-height:60vh; max-width:60vw;">
            <div class="flex lg:flex-col flex-row items-center gap-2 w-96">
                <!-- Make it scrollable -->
                {#each sorted_filtered_streamers as streamer}
                    {#if streamer.id != stream_id && streamer.twitch_id}
                        <a class="lg:mt-0 mt-10 lg:mb-0 mb-10 w-64 sm:w-64 md:w-64 lg:w-64" onclick="window.location='/stream/{streamer.id}'" href="#">
                            <div class="bg-pink-100 rounded-lg shadow-xl p-3">
                                <div class="flex flex-row items-center">
                                    <div class="ml-3">
                                        <h1 class="text-xl font-bold">{streamer.twitch_id}</h1>
                                    </div>
                                </div>
                                <div class="flex flex-row items-center mt-1 ml-2">
                                    <p class="md:text-sm">Vues :</p>
                                    <div class="grid grid-flow-col text-center auto-cols-max justify-center ml-1">
                                        {#each splitIntoDigits(streamer.view_count, 0) as count}
                                            <div class="flex flex-col font-mono text-lg">
                                                <Digit digit={count} />
                                            </div> 
                                        {/each}
                                    </div>
                                </div>
                            </div>
                        </a>
                    {/if}
                {/each}
                </div>
            </div>
    </div> 
</div>
{:else}
    <div class="mt-1 flex flex-col items-center justify-center h-max" max-width="1400px" style="max-height:800px">
        <div class="container">
            <h1 class="text-4xl font-bold">Stream non trouvé, redirection dans 3 secondes...</h1>
        </div>
    </div>
{/if}
